#ifndef __NATIVE_CODE_H
#define __NATIVE_CODE_H

#include "Windas.h"
#include "XedWrap.h"
#include "Code.h"

typedef struct _NATIVE_CODE_LINK
{
	_NATIVE_CODE_LINK*	Next;
	_NATIVE_CODE_LINK*	Prev;

	ULONG				Flags;
	ULONG				Label;
	PUCHAR				RawData;
	ULONG				RawDataSize;
	XED_DECODED_INST	XedInst;
	_NATIVE_CODE_LINK();
	_NATIVE_CODE_LINK(ULONG LabelId);
}NATIVE_CODE_LINK, *PNATIVE_CODE_LINK;

typedef struct _NATIVE_CODE_BLOCK
{
	PNATIVE_CODE_LINK Start;
	PNATIVE_CODE_LINK End;
}NATIVE_CODE_BLOCK, * PNATIVE_CODE_BLOCK;

VOID NcInsertLinkAfter(PNATIVE_CODE_LINK Link1, PNATIVE_CODE_LINK Link2);

VOID NcInsertLinkBefore(PNATIVE_CODE_LINK Link1, PNATIVE_CODE_LINK Link2);

VOID NcUnlink(PNATIVE_CODE_LINK Link);

VOID NcConcat(PNATIVE_CODE_BLOCK Block1, PNATIVE_CODE_BLOCK Block2);

VOID NcInsertBlockAfter(PNATIVE_CODE_LINK Link, PNATIVE_CODE_BLOCK Block);

VOID NcInsertBlockBfore(PNATIVE_CODE_LINK Link, PNATIVE_CODE_BLOCK Block);

BOOL NcCreateLabels(PNATIVE_CODE_BLOCK Block);

PNATIVE_CODE_LINK NcValidateJmp(PNATIVE_CODE_LINK Link, INT32 Delta);

BOOL NcFromBuffer(PNATIVE_CODE_BLOCK Block, PVOID Buffer, ULONG BufferSize);

VOID NcDelete(PNATIVE_CODE_BLOCK Block);


#endif